exception Exn of string

module P = Map.Make(struct type t = int let compare:int->int->int=compare end)

let nb_data = ref 0
let data = ref P.empty

let create d =
  let ind = !nb_data in
    data := P.add ind (Obj.repr d) !data;
    nb_data := succ ind;
    ind
;;

let alloc () = create 0;;

List.map create [
  [| "Out_of_memory" |];
  [| "Sys_error" |];
  [| "Failure" |];
  [| "Invalid_argument" |];
  [| "End_of_file" |];
  [| "Division_by_zero" |];
  [| "Not_found" |];
  [| "Match_failure" |];
  [| "Stack_overflow" |];
  [| "Sys_blocked_io" |];
  [| "Assert_failure" |];
  [| "Undefined_recursive_module" |];
];;

let export oc =
  let tab = Array.make !nb_data (Obj.repr 0) in
    P.iter (fun i d -> tab.(i) <- d) !data;
    output_value oc tab;
;;
